// Sorts long integers using the quick_sort method.
// Code from Wikipedia.

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


void swap(long int *a, long int *b)
{
  long int t=*a; *a=*b; *b=t;
}

void quick_sort_long(long int arr[], long int beg, long int end)
{
  if (end > beg + 1)
    {
      long int piv = arr[beg], l = beg + 1, r = end;
      while (l != r-1)
        {
          if(arr[l] <= piv)
            l++;
          else
            swap(&arr[l], &arr[r--]);
        }
      if(arr[l]<=piv && arr[r]<=piv)
        l=r+1;
      else if(arr[l]<=piv && arr[r]>piv)
        {l++; r--;}
      else if (arr[l]>piv && arr[r]<=piv)
        swap(&arr[l++], &arr[r--]);
      else
        r=l-1;

      swap(&arr[r--], &arr[beg]);
      quick_sort_long(arr, beg, r);
      quick_sort_long(arr, l, end);
    }
}
