#include <stdio.h>
#include <stdlib.h>
#include <math.h>

struct gcoef{
  float sum;
  float mx;
  float my;
  float phi;
  float lx;
  float ly;
};

sub_rdcoef4(long *fpos, FILE *f_psfin, long index[9], struct gcoef *gcoef, struct gcoef *gcoef1, long num_angs, short case_num)
{
  int i;
  short x0, x2, x3, x4;
  short y0, y2, y3, y4;
  short z0, z2, z3, z4;
 
  long fpos0, fpos2, fpos3, fpos4;
  long idx0, idx2, idx3, idx4;
  struct gcoef *gcoef0, *gcoef2, *gcoef3, *gcoef4;

  gcoef0 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
  gcoef2 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
  gcoef3 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
  gcoef4 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));

  if (case_num > 8){

    if (case_num == 9){
      idx0 = index[1]; idx2 = index[2]; idx3 = index[5]; idx4 = index[6];
    }
    else if (case_num == 10){
      idx0 = index[1]; idx2 = index[2]; idx3 = index[4]; idx4 = index[7];
    }
    else {
      idx0 = index[1]; idx2 = index[2]; idx3 = index[3]; idx4 = index[8];
    }
    for (i = 0; i < num_angs; i++){
      gcoef0[i].sum = gcoef1[i].sum;
      gcoef0[i].mx = gcoef1[i].mx; 
      gcoef0[i].my = gcoef1[i].my; 
      gcoef0[i].phi = gcoef1[i].phi; 
      gcoef0[i].lx = gcoef1[i].lx; 
      gcoef0[i].ly = gcoef1[i].ly;
    }
  }

  else {

    if (case_num == 6){
      idx0 = index[4]; idx2 = index[7]; idx3 = index[5]; idx4 = index[6];
    }
    else if (case_num == 7){
      idx0 = index[3]; idx2 = index[8]; idx3 = index[5]; idx4 = index[6];
    }
    else {
      idx0 = index[3]; idx2 = index[8]; idx3 = index[4]; idx4 = index[7];
    }
    //get all data at idx0
    fpos0 = fpos[idx0];
    fseek(f_psfin, fpos0, SEEK_SET);
    fread(&x0, sizeof(unsigned short), 1, f_psfin);
    fread(&y0, sizeof(unsigned short), 1, f_psfin);
    fread(&z0, sizeof(unsigned short), 1, f_psfin);
    fread(gcoef0, sizeof(struct gcoef), num_angs, f_psfin);
  }
  
  //get all data at vox_p2
  fpos2 = fpos[idx2];
  fseek(f_psfin, fpos2, SEEK_SET);
  fread(&x2, sizeof(unsigned short), 1, f_psfin);
  fread(&y2, sizeof(unsigned short), 1, f_psfin);
  fread(&z2, sizeof(unsigned short), 1, f_psfin);
  fread(gcoef2, sizeof(struct gcoef), num_angs, f_psfin);
   
  //get all data at vox_p3
  fpos3 = fpos[idx3];
  fseek(f_psfin, fpos3, SEEK_SET);
  fread(&x3, sizeof(unsigned short), 1, f_psfin);
  fread(&y3, sizeof(unsigned short), 1, f_psfin);
  fread(&z3, sizeof(unsigned short), 1, f_psfin);
  fread(gcoef3, sizeof(struct gcoef), num_angs, f_psfin);
  
  //get all data at vox_p4
  fpos4 = fpos[idx4];
  fseek(f_psfin, fpos4, SEEK_SET);
  fread(&x4, sizeof(unsigned short), 1, f_psfin);
  fread(&y4, sizeof(unsigned short), 1, f_psfin);
  fread(&z4, sizeof(unsigned short), 1, f_psfin);
  fread(gcoef4, sizeof(struct gcoef), num_angs, f_psfin);

  //perform interpolation
  sub_avgcoef4(gcoef, gcoef0, gcoef2, gcoef3, gcoef4, num_angs);
  
  free(gcoef2); free(gcoef3); free(gcoef4); free(gcoef0);
  
}
