#include <stdio.h>
#include <stdlib.h>
#include <math.h>

struct gcoef{
  float sum;
  float mx;
  float my;
  float phi;
  float lx;
  float ly;
};

sub_rdcoef8(long *fpos, FILE *f_psfin, long index[9], struct gcoef *gcoef, struct gcoef *gcoef1, long num_angs)
{
 short x2, x3, x4, x5, x6, x7, x8;
 short y2, y3, y4, y5, y6, y7, y8;
 short z2, z3, z4, z5, z6, z7, z8;
 
 long fpos2, fpos3, fpos4, fpos5, fpos6, fpos7, fpos8;
 long idx2, idx3, idx4, idx5, idx6, idx7, idx8;
 struct gcoef *gcoef2, *gcoef3, *gcoef4, *gcoef5, *gcoef6, *gcoef7, *gcoef8;

   gcoef2 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
   gcoef3 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
   gcoef4 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
   gcoef5 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
   gcoef6 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
   gcoef7 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));
   gcoef8 = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));

   idx2 = index[2]; idx3 = index[3]; idx4 = index[4]; idx5 = index[5];
   idx6 = index[6]; idx7 = index[7]; idx8 = index[8];

   //get all data at vox_p2
   fpos2 = fpos[idx2];
   fseek(f_psfin, fpos2, SEEK_SET);
   fread(&x2, sizeof(unsigned short), 1, f_psfin);
   fread(&y2, sizeof(unsigned short), 1, f_psfin);
   fread(&z2, sizeof(unsigned short), 1, f_psfin);
   fread(gcoef2, sizeof(struct gcoef), num_angs, f_psfin);
   
   //get all data at vox_p3
   fpos3 = fpos[idx3];
   fseek(f_psfin, fpos3, SEEK_SET);
   fread(&x3, sizeof(unsigned short), 1, f_psfin);
   fread(&y3, sizeof(unsigned short), 1, f_psfin);
   fread(&z3, sizeof(unsigned short), 1, f_psfin);
   fread(gcoef3, sizeof(struct gcoef), num_angs, f_psfin);
   
   //get all data at vox_p4
   fpos4 = fpos[idx4];
   fseek(f_psfin, fpos4, SEEK_SET);
   fread(&x4, sizeof(unsigned short), 1, f_psfin);
   fread(&y4, sizeof(unsigned short), 1, f_psfin);
   fread(&z4, sizeof(unsigned short), 1, f_psfin);
   fread(gcoef4, sizeof(struct gcoef), num_angs, f_psfin);

   //get all data at vox_p5
   fpos5 = fpos[idx5];
   fseek(f_psfin, fpos5, SEEK_SET);
   fread(&x5, sizeof(unsigned short), 1, f_psfin);
   fread(&y5, sizeof(unsigned short), 1, f_psfin);
   fread(&z5, sizeof(unsigned short), 1, f_psfin);
   fread(gcoef5, sizeof(struct gcoef), num_angs, f_psfin);
   
   //get all data at vox_p6
   fpos6 = fpos[idx6];
   fseek(f_psfin, fpos6, SEEK_SET);
   fread(&x6, sizeof(unsigned short), 1, f_psfin);
   fread(&y6, sizeof(unsigned short), 1, f_psfin);
   fread(&z6, sizeof(unsigned short), 1, f_psfin);
   fread(gcoef6, sizeof(struct gcoef), num_angs, f_psfin);
   
   //get all data at vox_p7
   fpos7 = fpos[idx7];
   fseek(f_psfin, fpos7, SEEK_SET);
   fread(&x7, sizeof(unsigned short), 1, f_psfin);
   fread(&y7, sizeof(unsigned short), 1, f_psfin);
   fread(&z7, sizeof(unsigned short), 1, f_psfin);
   fread(gcoef7, sizeof(struct gcoef), num_angs, f_psfin);

   //get all data at vox_p8
   fpos8 = fpos[idx8];
   fseek(f_psfin, fpos8, SEEK_SET);
   fread(&x8, sizeof(unsigned short), 1, f_psfin);
   fread(&y8, sizeof(unsigned short), 1, f_psfin);
   fread(&z8, sizeof(unsigned short), 1, f_psfin);
   fread(gcoef8, sizeof(struct gcoef), num_angs, f_psfin);
 
   //perform interpolation
   sub_avgcoef8(gcoef, gcoef1, gcoef2, gcoef3, gcoef4, gcoef5, gcoef6, gcoef7, gcoef8, num_angs);

   free(gcoef2); free(gcoef3); free(gcoef4);
   free(gcoef5); free(gcoef6); free(gcoef7); free(gcoef8);

}
